#!/bin/python
import DRMAA
from sys import argv, exit
from time import sleep
from pprint import pprint
from datetime import datetime

NBULKS = 3
JOB_CHUNK = 5

OPATH=":"+DRMAA.JobTemplate.HOME_DIRECTORY+'/DRMAA_JOB_OUT'

def init_job_template(jt, path, args, as_bulk_job):
    jt.workingDirectory = DRMAA.JobTemplate.HOME_DIRECTORY
    jt.remoteCommand = path
    jt.args = args
    jt.joinFiles=True
    jt.startTime=datetime.now()
    print "start time is: ", jt.startTime
    if as_bulk_job:
        jt.outputPath=OPATH+'.'+DRMAA.JobTemplate.PARAMETRIC_INDEX
    else:
        jt.outputPath=OPATH
    return jt


def main():
    if len(argv) < 2:
        print "usage: example.py <path-to-job> <arguments>"
        exit(1)
    job_path=argv[1]
    s=DRMAA.Session()
    s.init()
    # submit some bulk jobs
    jt=init_job_template(s.createJobTemplate(), job_path, argv[2:], True)
    all_jobids = []
    for i in range(NBULKS):
        all_jobids += s.runBulkJobs(jt, 1, JOB_CHUNK, 1)
        sleep(1)
    print "submitted bulk jobs with jobids:"
    pprint(all_jobids)
    # submit some sequential jobs
    s.deleteJobTemplate(jt)
    del jt
    jt=init_job_template(s.createJobTemplate(), job_path, argv[2:], False)
    for i in range(NBULKS):
        all_jobids.append(s.runJob(jt))
        sleep(1)
    s.synchronize(all_jobids,
                  DRMAA.Session.TIMEOUT_WAIT_FOREVER,
                  False)
    print "synchronized with all jobs"
    for jid in all_jobids:
        info=s.wait(jid, DRMAA.Session.TIMEOUT_WAIT_FOREVER)
        print '='*76
        for k in info.__dict__:
            print k
            pprint(getattr(info, k))
            print '-'*76        

if __name__=='__main__':
    main()
